#!/usr/bin/perl

my $STATE_NONE     = 0;
my $STATE_IMPORT   = 1;
my $STATE_CHECKOUT = 2;
my $STATE_UPDATE   = 3;
my $STATE_COMMIT   = 4;
my $STATE_INDEX_0  = 5;
my $STATE_INDEX_1  = 6;

my $state = 0;

my $import = 0;
my $checkout_hot = 0;
my $checkout_cold = 0;
my $commit_lines = 0;

my $last_lines;
my $last_files;
my $last_recr;
my $update_recr = 0;
my $last_st;
my $last_sy;
my $last_lr;

my $import_st;
my $checkout_st_0;
my $checkout_st_1;
my $checkout_recr;

my @commit_files;
my @commit_records;
my @update_records;

my @update_times_0;
my @update_times_1;
my @commit_times_0;
my @commit_times_1;

my @commit_st_0;
my @commit_st_1;
my @update_st_0;
my @update_st_1;

my @commit_sync_0;
my @commit_sync_1;
my @update_recr_0;
my @update_recr_1;

my @load_vl_u_0;
my @load_vl_u_1;
my @load_vl_c_0;
my @load_vl_c_1;

my @inserts_l_0;
my @inserts_l_t_0;
my @inserts_0;
my @inserts_t_0;
my @retrieves_l_0;
my @retrieves_l_t_0;
my @retrieves_0;
my @retrieves_t_0;

my @inserts_l_1;
my @inserts_l_t_1;
my @inserts_1;
my @inserts_t_1;
my @retrieves_l_1;
my @retrieves_l_t_1;
my @retrieves_1;
my @retrieves_t_1;

my $which = 0;
my $mark;

while (<>) {
  if ($state == $STATE_INDEX_0) {
    if ($_ =~ /^(\d+)/) {
      if ($1 > 0) { push @commit_files, $1; }
      $last_files = $1;
      $state = $STATE_INDEX_1;
    }
    next;
  }
  elsif ($_ =~ /build snapshot before ([0-9]+) ms/) {
    my $t = $1;
    if ($state == $STATE_UPDATE) {
      $last_st = $t;
      if ($last_files != 0) {
        if ($which == 0) { push @update_st_0, $t; }
        if ($which == 1) { push @update_st_1, $t; }
      }
    }
    elsif ($state == $STATE_CHECKOUT) {
      if ($checkout_hot == 0) { $checkout_st_0 = $t; }
      else { $checkout_st_1 = $t; }
    }
  }
  elsif ($_ =~ /build snapshot after ([0-9]+) ms/) {
    my $t = $1;
    if ($state == $STATE_COMMIT) {
      $last_st = $t;
      if ($last_files != 0) {
        if ($which == 0) { push @commit_st_0, $t; }
        if ($which == 1) { push @commit_st_1, $t; }
      }
    }
    elsif ($state == $STATE_IMPORT) { $import_st = $t; }
  }
  elsif ($_ =~ /sync log after (\d+) ms/) {
    my $t = $1;
    if ($state == $STATE_COMMIT) {
      $last_sy = $t;
      if ($last_files != 0) {
        if ($which == 0) { push @commit_sync_0, $t; }
        if ($which == 1) { push @commit_sync_1, $t; }
      }
    }
  }
  elsif ($_ =~ /load records for snapshot in (\d+) ms/) {
    my $t = $1;
    if ($state == $STATE_UPDATE) {
      $last_lr = $t;
      if ($last_files != 0) {
        if ($which == 0) { push @update_recr_0, $t; }
        if ($which == 1) { push @update_recr_1, $t; }
      }
    }
    elsif ($state == $STATE_CHECKOUT) { $checkout_recr = $t; }
  }
  elsif ($_ =~ /load view and log after (\d+) ms/) {
    if ($last_files != 0) {
      if ($state == $STATE_UPDATE) {
        if ($which == 0) { push @load_vl_u_0, $1; }
        if ($which == 1) { push @load_vl_u_1, $1; }
      }
      elsif ($state == $STATE_COMMIT) {
        if ($which == 0) { push @load_vl_c_0, $1; }
        if ($which == 1) { push @load_vl_c_1, $1; }
      }
    }
  }
  elsif ($_ =~ /^[0-9.]+u [0-9.]+s ([0-9]+):([0-9][0-9]).([0-9][0-9])/) {
    my $t = $1*60+$2+$3/100;

    if ($state == $STATE_IMPORT) {
      $import = $t;
    }
    elsif ($state == $STATE_CHECKOUT) {
      if ($checkout_hot == 0) { $checkout_hot = $t; }
      else { $checkout_cold = $t; }
    }
    elsif ($state == $STATE_COMMIT) {
      if ($last_files != 0) {
        if ($which == 0) { push @commit_times_0, $t; }
        if ($which == 1) { push @commit_times_1, $t; }
        print "$which c $t $last_files $last_recr $last_st $last_sy\n";
      }
    }
    elsif ($state == $STATE_UPDATE) {
      if ($last_files != 0) {
        if ($which == 0) { push @update_times_0, $t; }
        if ($which == 1) { push @update_times_1, $t; }
        print "$which u $t $last_files $update_recr $last_st $last_lr\n";
	push @update_records, $update_recr;
	$update_recr = 0;
      }
    }
  }
  elsif ($_ =~ /([0-9.]+) real/) {
    my $t = $1;
    if ($state == $STATE_IMPORT) {
      $import = $1;
    }
    elsif ($state == $STATE_CHECKOUT) {
      if ($checkout_hot == 0) { $checkout_hot = $1; }
      else { $checkout_cold = $1; }
    }
    elsif ($state == $STATE_COMMIT) {
      if ($last_files != 0) {
	if ($which == 0) { push @commit_times_0, $t; }
        if ($which == 1) { push @commit_times_1, $t; }
        print "$which c $t $last_files $last_recr $last_st $last_sy\n";
      }
    }
    elsif ($state == $STATE_UPDATE) {
      if ($last_files != 0) {
        if ($which == 0) { push @update_times_0, $t; }
        if ($which == 1) { push @update_times_1, $t; }
        print "$which u $t $last_files $update_recr $last_st $last_lr\n";
	push @update_records, $update_recr;
	$update_recr = 0;
      }
    }
  }
  elsif ($_ =~ /il (\d+) \((\d+).\d+\), i (\d+) \((\d+).\d+\), rl (\d+) \((\d+).\d+\), r (\d+) \((\d+).\d+\)/) {
    if ($state == $STATE_COMMIT) {
      if ($which == 0) {
        push @inserts_l_0, $1;
	push @inserts_l_t_0, $2;
	push @inserts_0, $3;
	push @inserts_t_0, $4
      }
      if ($which == 1) {
        push @inserts_l_1, $1;
	push @inserts_l_t_1, $2;
	push @inserts_1, $3;
	push @inserts_t_1, $4
      }
    }
    elsif ($state == $STATE_UPDATE) {
      if ($which == 0) {
        push @retrieves_l_0, $5;
	push @retrieves_l_t_0, $6;
	push @retrieves_0, $7;
	push @retrieves_t_0, $8
      }
      if ($which == 1) {
        push @retrieves_l_1, $5;
	push @retrieves_l_t_1, $6;
	push @retrieves_1, $7;
	push @retrieves_t_1, $8
      }
    }
  }
  elsif ($_ =~ /^Import$/) {
    $state = $STATE_IMPORT;
  }
  elsif ($_ =~ /^Checkout/) {
    $state = $STATE_CHECKOUT;
  }
  elsif ($_ =~ /^Update Warm/) {
    $state = $STATE_UPDATE;
    if ($_ =~ /^Update Warm ([01])/) {
      $which = $1;
    }
  }
  elsif ($_ =~ /^Commit/) {
    $state = $STATE_COMMIT;
    if ($_ =~ /^Commit ([01])/) {
      $which = $1;
    }
  }
  elsif ($_ =~ /([0-9]+) records$/) {
    if ($state == $STATE_COMMIT) {
      push @commit_records, $1;
      $last_recr = $1;
      $update_recr += $1;
    }
  }
  elsif ($_ =~ /^\s+([0-9]+)\s+([0-9]+)\s+([0-9]+) diffs_([0-9_]+)/) {
    $mark = $4;
    $commit_lines += $1;
    $last_lines = $1;
  }
  elsif ($_ =~ /^\s+([0-9]+)\s+([0-9]+)\s+([0-9]+) patch-([0-9_]+)/) {
    $mark = $4;
    $commit_lines += $1;
    $last_lines = $1;
  }
  elsif ($_ =~ /^===== /) {
    $state = $STATE_INDEX_0;
  }
  elsif ($_ =~ /^Done Commit/) {
  }
  elsif ($_ =~ /^Done Update/) {
    $state = $STATE_NONE;
  }
}

sub sum {
  my @v = @_;
  $sum = 0;
  for ($i = 0; $i <= $#v; $i++) {
    $sum += $v[$i];
  }
  return $sum;
}

sub avg {
  my @v = @_;
  $sum = sum(@v);
  return $sum/($#v+1);
}

sub std {
  my @v = @_;
  $avg = avg(@v);
  $var = 0;
  for ($i = 0; $i <= $#v; $i++) {
    $var += (($v[$i]-$avg)**2);
  }
  return sqrt($var/($#v+1));
}

sub qunt {
  my ($m, @v) = @_;
  $i = $#v * $m;
  return $v[$i];
}

@commit_files = sort {$a <=> $b} @commit_files;
@commit_records = sort {$a <=> $b} @commit_records;
@update_records = sort {$a <=> $b} @update_records;

@update_times_0 = sort {$a <=> $b} @update_times_0;
@update_times_1 = sort {$a <=> $b} @update_times_1;
@commit_times_0 = sort {$a <=> $b} @commit_times_0;
@commit_times_1 = sort {$a <=> $b} @commit_times_1;

@update_st_0 = sort {$a <=> $b} @update_st_0;
@update_st_1 = sort {$a <=> $b} @update_st_1;
@commit_st_0 = sort {$a <=> $b} @commit_st_0;
@commit_st_1 = sort {$a <=> $b} @commit_st_1;

@update_recr_0 = sort {$a <=> $b} @update_recr_0;
@update_recr_1 = sort {$a <=> $b} @update_recr_1;
@commit_sync_0 = sort {$a <=> $b} @commit_sync_0;
@commit_sync_1 = sort {$a <=> $b} @commit_sync_1;

@load_vl_u_0 = sort {$a <=> $b} @load_vl_u_0;
@load_vl_u_1 = sort {$a <=> $b} @load_vl_u_1;
@load_vl_c_0 = sort {$a <=> $b} @load_vl_c_0;
@load_vl_c_1 = sort {$a <=> $b} @load_vl_c_1;

@inserts_l_0 = sort {$a <=> $b} @inserts_l_0;
@inserts_l_t_0 = sort {$a <=> $b} @inserts_l_t_0;
@inserts_0 = sort {$a <=> $b} @inserts_0;
@inserts_t_0 = sort {$a <=> $b} @inserts_t_0;
@retrieves_l_0 = sort {$a <=> $b} @retrieves_l_0;
@retrieves_l_t_0 = sort {$a <=> $b} @retrieves_l_t_0;
@retrieves_0 = sort {$a <=> $b} @retrieves_0;
@retrieves_t_0 = sort {$a <=> $b} @retrieves_t_0;

@inserts_l_1 = sort {$a <=> $b} @inserts_l_1;
@inserts_l_t_1 = sort {$a <=> $b} @inserts_l_t_1;
@inserts_1 = sort {$a <=> $b} @inserts_1;
@inserts_t_1 = sort {$a <=> $b} @inserts_t_1;
@retrieves_l_1 = sort {$a <=> $b} @retrieves_l_1;
@retrieves_l_t_1 = sort {$a <=> $b} @retrieves_l_t_1;
@retrieves_1 = sort {$a <=> $b} @retrieves_1;
@retrieves_t_1 = sort {$a <=> $b} @retrieves_t_1;


print "# machine c/u time files records snapshot_time sync/load_recr\n";
print "# $mark\n";

printf ("       import  %5.1f ", $import);
if ($import_st > 0) {
  printf ("(snapshot %4.1f)\n", $import_st/1000);
}
else { printf ("\n"); }
printf ("     checkout  %5.1f\n", $checkout_hot);
printf ("     checkout  %5.1f ", $checkout_cold);
if ($checkout_st_1 > 0) {
  printf ("(snapshot %4.1f recr %4.1f)\n",
          $checkout_st_1/1000, $checkout_recr/1000);
}
else { printf ("\n"); }
printf ("    avg files  %5.1f\n", avg (@commit_files));
printf ("    med files  %5.1f\n", qunt (0.5, @commit_files));

if ($#commit_records >= 0) {
  printf ("    avg recrs  %5.1f\n", avg (@commit_records));
  printf ("    med recrs  %5.1f\n", qunt (0.5, @commit_records));
}

if ($#update_records >= 0) {
  printf ("    avg delts  %5.1f\n", avg (@update_records));
  printf ("    med delts  %5.1f\n", qunt (0.5, @update_records));
}

printf ("    machine 0\n");
  
if ($#commit_times_0 >= 0) {
  printf ("   sum commit  %5.1f\n", sum (@commit_times_0));
  printf ("   avg commit  %5.1f (", avg (@commit_times_0));
  if ($#load_vl_c_0 >= 0)
    { printf ("view %4.1f ", avg (@load_vl_c_0)/1000); }
  if ($#commit_st_0 >= 0) 
    { printf ("snapshot %4.1f ", avg (@commit_st_0)/1000); }
  if ($#commit_sync_0 >= 0) 
    { printf ("sync %4.1f ", avg (@commit_sync_0)/1000); }
  print ")\n";
  
  printf ("   med commit  %5.1f (", qunt (0.5, @commit_times_0));
  if ($#load_vl_c_0 >= 0)
    { printf ("view %4.1f ", qunt (0.5, @load_vl_c_0)/1000); }
  if ($#commit_st_0 >= 0) 
    { printf ("snapshot %4.1f ", qunt (0.5, @commit_st_0)/1000); }
  if ($#commit_sync_0 >= 0) 
    { printf ("sync %4.1f ", qunt (0.5, @commit_sync_0)/1000); }
  print ")\n";

  if ($#inserts_l_0 >= 0) {
    if (0) {
      printf ("   avg cachei %6d (avg time %.1f ms)\n",
              avg (@inserts_l_0), avg (@inserts_l_t_0));
      printf ("   med cachei %6d (med time %.1f ms)\n",
              qunt (0.5, @inserts_l_0), qunt (0.5, @inserts_l_t_0));
    }
    printf ("   avg insert %6d (avg time %.1f ms)\n",
            avg (@inserts_0), avg (@inserts_t_0));
    printf ("   med insert %6d (med time %.1f ms)\n",
            qunt (0.5, @inserts_0), qunt (0.5, @inserts_t_0));
  }
}

if ($#update_times_0 >= 0) {
  printf ("   sum update  %5.1f\n", sum (@update_times_0));
  printf ("   avg update  %5.1f (", avg (@update_times_0));
  if ($#load_vl_u_0 >= 0)
    { printf ("view %4.1f ", avg (@load_vl_u_0)/1000); }
  if ($#update_st_0 >= 0) 
    { printf ("snapshot %4.1f ", avg (@update_st_0)/1000); }
  if ($#update_recr_0 >= 0) 
    { printf ("recr %4.1f ", avg (@update_recr_0)/1000); }
  print ")\n";
  
  printf ("   med update  %5.1f (", qunt (0.5, @update_times_0));
  if ($#load_vl_u_0 >= 0)
    { printf ("view %4.1f ", qunt (0.5, @load_vl_u_0)/1000); }
  if ($#update_st_0 >= 0) 
    { printf ("snapshot %4.1f ", qunt (0.5, @update_st_0)/1000); }
  if ($#update_recr_0 >= 0) 
    { printf ("recr %4.1f ", qunt (0.5, @update_recr_0)/1000); }
  print ")\n";
  
  if ($#retrieves_l_0 >= 0) {
    if (0) {
      printf ("   avg cachel %6d (avg time %.1f ms)\n",
              avg (@retrieves_l_0), avg (@retrieves_l_t_0));
      printf ("   med cachel %6d (med time %.1f ms)\n",
              qunt (0.5, @retrieves_l_0), qunt (0.5, @retrieves_l_t_0));
    }
    printf ("   avg lookup %6d (avg time %.1f ms)\n",
            avg (@retrieves_0), avg (@retrieves_t_0));
    printf ("   med lookup %6d (med time %.1f ms)\n",
            qunt (0.5, @retrieves_0), qunt (0.5, @retrieves_t_0));
  }
}

printf ("    machine 1\n");

if ($#commit_times_1 >= 0) {
  printf ("   sum commit  %5.1f\n", sum (@commit_times_1));
  printf ("   avg commit  %5.1f (", avg (@commit_times_1));
  if ($#load_vl_c_1 >= 0)
    { printf ("view %4.1f ", avg (@load_vl_c_1)/1000); }
  if ($#commit_st_1 >= 0) 
    { printf ("snapshot %4.1f ", avg (@commit_st_1)/1000); }
  if ($#commit_sync_1 >= 0) 
    { printf ("sync %4.1f ", avg (@commit_sync_1)/1000); }
  print ")\n";
  
  printf ("   med commit  %5.1f (", qunt (0.5, @commit_times_1));
  if ($#load_vl_c_1 >= 0)
    { printf ("view %4.1f ", qunt (0.5, @load_vl_c_1)/1000); }
  if ($#commit_st_1 >= 0) 
    { printf ("snapshot %4.1f ", qunt (0.5, @commit_st_1)/1000); }
  if ($#commit_sync_1 >= 0) 
    { printf ("sync %4.1f ", qunt (0.5, @commit_sync_1)/1000); }
  print ")\n";

  if ($#inserts_l_1 >= 0) {
    if (0) {
      printf ("   avg cachei %6d (avg time %.1f ms)\n",
              avg (@inserts_l_1), avg (@inserts_l_t_1));
      printf ("   med cachei %6d (med time %.1f ms)\n",
              qunt (0.5, @inserts_l_1), qunt (0.5, @inserts_l_t_1));
    }
    printf ("   avg insert %6d (avg time %.1f ms)\n",
            avg (@inserts_1), avg (@inserts_t_1));
    printf ("   med insert %6d (med time %.1f ms)\n",
            qunt (0.5, @inserts_1), qunt (0.5, @inserts_t_1));
  }
}

if ($#update_times_1 >= 0) {
  printf ("   sum update  %5.1f\n", sum (@update_times_1));
  printf ("   avg update  %5.1f (", avg (@update_times_1));
  if ($#load_vl_u_1 >= 0)
    { printf ("view %4.1f ", avg (@load_vl_u_1)/1000); }
  if ($#update_st_1 >= 0) 
    { printf ("snapshot %4.1f ", avg (@update_st_1)/1000); }
  if ($#update_recr_1 >= 0) 
    { printf ("recr %4.1f ", avg (@update_recr_1)/1000); }
  print ")\n";
  
  printf ("   med update  %5.1f (", qunt (0.5, @update_times_1));
  if ($#load_vl_u_1 >= 0)
    { printf ("view %4.1f ", qunt (0.5, @load_vl_u_1)/1000); }
  if ($#update_st_1 >= 0) 
    { printf ("snapshot %4.1f ", qunt (0.5, @update_st_1)/1000); }
  if ($#update_recr_1 >= 0) 
    { printf ("recr %4.1f ", qunt (0.5, @update_recr_1)/1000); }
  print ")\n";
  
  if ($#retrieves_l_1 >= 0) {
    if (0) {
      printf ("   avg cachel %6d (avg time %.1f ms)\n",
              avg (@retrieves_l_1), avg (@retrieves_l_t_1));
      printf ("   med cachel %6d (med time %.1f ms)\n",
              qunt (0.5, @retrieves_l_1), qunt (0.5, @retrieves_l_t_1));
    }
    printf ("   avg lookup %6d (avg time %.1f ms)\n",
            avg (@retrieves_1), avg (@retrieves_t_1));
    printf ("   med lookup %6d (med time %.1f ms)\n",
            qunt (0.5, @retrieves_1), qunt (0.5, @retrieves_t_1));
  }
}

