#!/usr/bin/perl

my $module = "sfs1";
my $users = 2;
my $srv = "nyu.ron.lcs.mit.edu:/usr/home/benjie/cvsroot";

#
# first machine
#

my $mach0  = "fission.lcs.mit.edu";
my $home0  = "/usr/tmp/benjie/pastwatch.dist";
my $w0     = "$home0/exp/$mach0/w0";
my $past0  = "cvs";
my $dir0   = "$home0/exp/";
my $base   = "$home0/exp/base";   # only used for import

#
# second machine
#

my $mach1  = "ana1-gblx.ron.lcs.mit.edu";
my $home1  = "/users/home/benjie/pastwatch.dist";
my $w1     = "$home1/exp/$mach1/w1";
my $past1  = "cvs";
my $dir1   = "$home1/exp/";

system ("date");

# first, create a view

ssh ($mach0, "setenv CVS_RSH ssh; $past0 -d $srv init");

# then, start working on two separate client machines

ssh ($mach0, "rm -rf $w0; mkdir -p $w0");
ssh ($mach1, "rm -rf $w1; mkdir -p $w1");

ssh ($mach0, "echo Import; cd $base; setenv CVS_RSH ssh; time $past0 -d $srv import -m checkin $module ABCD ABCDE; echo Done Import");

ssh ($mach0, "sleep 15; cd $w0; echo Checkout Hot; setenv CVS_RSH ssh; time $past0 -d $srv checkout $module; echo Done Checkout Hot");

ssh ($mach1, "sleep 15; cd $w1; echo Checkout Cold; setenv CVS_RSH ssh; time $past1 -d $srv checkout $module; echo Done Checkout Cold");

sub doit {
  my ($w, $diffs) = @_;

  if ($w == 0) {
    ssh ($mach0, "sleep 5; cd $dir0; echo ===== $diffs ======; grep -c Index $diffs; wc $diffs");
    ssh ($mach0, "cd $w0; patch -f < $dir0/$diffs");
    ssh ($mach0, "cd $w0; /bin/rm -rf `find $module -print | grep \".orig\" | xargs`");
    ssh ($mach0, "cd $w0; /bin/rm -rf `find $module -print | grep \".rej\" | xargs`");
    ssh ($mach0, "cd $w0; /bin/rm -rf $w0/zzz; setenv CVS_RSH ssh; $past0 -d $srv update $module > $w0/zzz");
    ssh ($mach0, "cd $w0; setenv CVS_RSH ssh; $dir0/add-cvs.pl $srv $w0/zzz");
    ssh ($mach0, "echo Commit 0; cd $w0; setenv CVS_RSH ssh; time $past0 -d $srv commit -m $diffs $module; echo Done Commit 0");
    ssh ($mach0, "cd $w0; setenv CVS_RSH ssh; $past0 -d $srv update $module");
    ssh ($mach1, "sleep 5; echo Update Warm 1; cd $w1; setenv CVS_RSH ssh; time $past1 -d $srv update $module; echo Done Update Warm 1");
  }
  
  else {
    ssh ($mach1, "sleep 5; cd $dir1; echo ===== $diffs ======; grep -c Index $diffs; wc $diffs");
    ssh ($mach1, "cd $w1; patch -f < $dir1/$diffs");
    ssh ($mach1, "cd $w1; /bin/rm -rf `find $module -print | grep \".orig\" | xargs`");
    ssh ($mach1, "cd $w1; /bin/rm -rf `find $module -print | grep \".rej\" | xargs`");
    ssh ($mach1, "cd $w1; /bin/rm -rf $w1/zzz; setenv CVS_RSH ssh; $past1 -d $srv update $module > $w1/zzz");
    ssh ($mach1, "cd $w1; setenv CVS_RSH ssh; $dir1/add-cvs.pl $srv $w1/zzz");
    ssh ($mach1, "echo Commit 1; cd $w1; setenv CVS_RSH ssh; time $past1 -d $srv commit -m $diffs $module; echo Done Commit 1");
    ssh ($mach1, "cd $w1; setenv CVS_RSH ssh; $past1 -d $srv update $module");
    ssh ($mach0, "sleep 5; echo Update Warm 0; cd $w0; setenv CVS_RSH ssh; time $past0 -d $srv update $module; echo Done Update Warm 0");
  }
}

sub ssh {
  my($h, $cmd) = @_;
  my $c = "ssh -x $h '$cmd'";
  my $status = system($c);
  return $status;
}

system ("sleep 5; date");

doit (0, "patch-200");
doit (1, "patch-201");
doit (0, "patch-202");
doit (1, "patch-203");
doit (0, "patch-204");
doit (1, "patch-205");
doit (0, "patch-206");
doit (1, "patch-207");
doit (0, "patch-208");
doit (1, "patch-209");
doit (0, "patch-210");
doit (1, "patch-211");
doit (0, "patch-212");
doit (1, "patch-213");
doit (0, "patch-214");
doit (1, "patch-215");
doit (0, "patch-216");
doit (1, "patch-217");
doit (0, "patch-218");
doit (1, "patch-219");
doit (0, "patch-220");
doit (1, "patch-221");
doit (0, "patch-222");
doit (1, "patch-223");
doit (0, "patch-224");
doit (1, "patch-225");
doit (0, "patch-226");
doit (1, "patch-227");
doit (0, "patch-228");
doit (1, "patch-229");
doit (0, "patch-230");
doit (1, "patch-231");
doit (0, "patch-232");
doit (1, "patch-233");
doit (0, "patch-234");
doit (1, "patch-235");
doit (0, "patch-236");
doit (1, "patch-237");
doit (0, "patch-238");
doit (1, "patch-239");

system ("date");

