#!/usr/bin/perl
#
# example
#
# tcpdump -vnltt port 22220 | perl bwmon.pl -
#

use IO::Socket;
use IPC::Shareable;

STDERR->autoflush(1);
STDOUT->autoflush(1);

$data = 0;
$tdata = 0;
$t0 = 0;
$h0 = tie $bwT, 'IPC::Shareable', undef, { destroy => 1 };
$h1 = tie $bwT0, 'IPC::Shareable', undef, { destroy => 1 };
$h2 = tie $tdata, 'IPC::Shareable', undef, { destroy => 1 };

$pid = fork ();

if ($pid == 0)
{
  my $sock = new IO::Socket::INET
    (LocalPort => 22219, Proto => 'tcp', Listen => 5, Reuse => 1);
  die "Could not create socket: $!\n" unless $sock;
  while ($new_sock = $sock->accept ()) {
    my $t = localtime;
    print $new_sock "$t $bwT $bwT0 $tdata\n";
    close ($new_sock);
  }
}

else 
{
  while (<>) {
    my @f = split;
    my $t = $f[0];
    my $l = int ($f[$#f]);
    if ($t0 == 0) { $t0 = $t; }
    $data += $l;
    $tdata += $l;
    if ($t-$t0 > 2) {
      my $n = ($data*8/($t-$t0))/1e6;  # Mbit/sec
      if ($bwT == 0) { $bwT = $n; }
      else { $bwT = ($bwT*19+$n)/20; }
      if ($bwT0 == 0) { $bwT0 = $n; }
      else { $bwT0 = ($bwT0*9+$n)/10; }
      $t0 = 0;
      $data = 0;
    }
  }
  kill 9, $pid;
}

