#!/usr/local/bin/perl

use IO::Socket;
STDERR->autoflush(1);
STDOUT->autoflush(1);

if ($#ARGV != 2) { die "Usage: prog aqua_port time0 node_list\n"; }

my $aquaport = $ARGV[0];
shift @ARGV;
my $time0 = $ARGV[0];
shift @ARGV;

@hosts;
@host_bw;
$unknown = 0;

while (<>) {
  chomp;
  push @hosts, $_;
  push @host_bw, 0;
}

sub getbw {
  my $t = time;
  for (my $i=0; $i <= $#hosts; $i++) {
    my $h = $hosts[$i];
    my $sock = new IO::Socket::INET 
      (PeerAddr => $h, PeerPort => $aquaport-1, Proto => 'tcp');
    if ($sock) {
      while (<$sock>) {
        if ($_ =~ /^([\s\S]+) ([0-9]+.[0-9]+) ([0-9]+.[0-9]+)\n$/) {
	  $host_bw[$i] = $3;
	  last;
	}
      }
    }
    else {
      $host_bw[$i] = 0;
    }
  }
}

sub printbw {
  my $t = time - $time0;
  printf ("# ");
  for (my $i=0; $i <= $#hosts; $i++) {
    my $h = substr ($hosts[$i], 0, index ($hosts[$i],"."));
    # my $h = substr ($hosts[$i], 0, 16);
    printf ("$h ");
  }
  printf ("\n$t ");
  for (my $i=0; $i <= $#hosts; $i++) {
    printf ("%.3f ", $host_bw[$i]*1000/8);
  }
  printf ("\n");
}

getbw ();
printbw ();

