#include "rxx.h"
#include "path.h"
#include "metadata.h"

info_file::info_file() {
  projlabel = "";
  logkey = "";
  projid = "";
  last_cr = "";
  branchlabel = "";
}
info_file::~info_file() {}


int
info_file::read_file(str path) {
  str use_path = get_info_file (get_parent_dir (path));
  str buf = file2str (use_path);
  if (!buf) {
    warn << "could not read info file(1) " << use_path << "\n";
    use_path = get_info_file (get_dir (path));
    buf = file2str (use_path);
  }
  if (!buf) {
    warn << "could not read info file(2) " << use_path << "\n";
    return -1;
  }
  
  // parse the file
  vec<str> lines;
  split (&lines, "\n", buf);
  if (lines.size () < 4) {
    warn << "Error parsing info file: " << use_path << "\n";
    return -1;
  }
  
  projlabel = lines[0];
  logkey = lines[1];
  last_cr = lines[3];
  if (lines.size () > 4)
    branchlabel = lines[4];
  
  if (!dearmor64A_bigint (lines [2], projid)) {
    warn << "Error parsing info file: " << use_path << "\n";
    return -1;
  }
  return 0;
}

str
info_file::get_projlabel () const {
  return projlabel;
}

str
info_file::get_logkey () const {
  return logkey;
}

bigint
info_file::get_projid () const {
  return projid;
}

str
info_file::get_last_cr () const {
  return last_cr;
}

str
info_file::get_branchlabel () const {
  return branchlabel;
}

