/*
 *  Copyright (C) 2002-2004  Massachusetts Institute of Technology
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */

#ifndef PASTWATCH_OPTS_H
#define PASTWATCH_OPTS_H

extern const int cmd_import;
extern const int cmd_checkout;
extern const int cmd_update;
extern const int cmd_commit;
extern const int cmd_rtag;
extern const int cmd_rename;
extern const int cmd_add;
extern const int cmd_remove;
extern const int cmd_clear;
extern const int cmd_diff;
extern const int cmd_status;
extern const int cmd_log;
extern const int cmd_rescue;
extern const int cmd_branch;
extern const int cmd_fetch;
extern const int cmd_merge;
extern const int cmd_latest;
extern const int cmd_history;
extern const int cmd_tags;
extern const int cmd_sync;

extern str cmd2str (int cmd);

extern str  arg_localpath;
extern str  arg_projstr;
extern str  arg_logkeyfile;
extern str  arg_userkeyfile;
extern str  arg_keystr;
extern str  arg_message;
extern str  arg_branch;
extern str  arg_branchtag;
extern str  arg_jointag;
extern str  arg_branchfrom;
extern str  arg_tag[2];
extern str  arg_date[2];
extern str  arg_timestamp;
extern str  arg_newtag;

extern int  arg_debugmode;
extern int  arg_command;
extern int  arg_revision[2];
extern bool arg_resetsticky;
extern bool arg_noupdate;
extern bool arg_readonly;
extern bool arg_updatedir;
extern bool arg_checkonly;
extern bool arg_force;
extern bool arg_contextdiff;
extern bool arg_relink;
extern bool arg_dironly;
extern bool arg_recurse;
extern bool arg_newbranch;
extern bool arg_killbranch;
extern bool arg_notrans;
extern bool arg_ignore_implicit_branches;
extern bool arg_sync_push;

extern bigint arg_projid;
extern bigint arg_key;
extern bigint arg_handle;

extern vec<str> arg_projids;
extern vec<str> arg_userkeys;
extern vec<str> arg_logkeys;
extern vec<str> arg_branches;
extern vec<ptr<vec<str> > > arg_paths;

#endif

